    ---------------------------------------------------------------------------
    -- FMC slot {n} pins (TDC mezzanine)
    ---------------------------------------------------------------------------

    -- TDC1 PLL AD9516 and DAC AD5662 interface
    fmc{n}_tdc_pll_sclk_o       : out std_logic;
    fmc{n}_tdc_pll_sdi_o        : out std_logic;
    fmc{n}_tdc_pll_cs_n_o       : out std_logic;
    fmc{n}_tdc_pll_dac_sync_n_o : out std_logic;
    fmc{n}_tdc_pll_sdo_i        : in  std_logic;
    fmc{n}_tdc_pll_status_i     : in  std_logic;
    fmc{n}_tdc_125m_clk_p_i     : in  std_logic;
    fmc{n}_tdc_125m_clk_n_i     : in  std_logic;
    fmc{n}_tdc_acam_refclk_p_i  : in  std_logic;
    fmc{n}_tdc_acam_refclk_n_i  : in  std_logic;

    -- TDC1 ACAM timing interface
    fmc{n}_tdc_start_from_fpga_o : out std_logic;
    fmc{n}_tdc_err_flag_i        : in  std_logic;
    fmc{n}_tdc_int_flag_i        : in  std_logic;
    fmc{n}_tdc_start_dis_o       : out std_logic;
    fmc{n}_tdc_stop_dis_o        : out std_logic;

    -- TDC1 ACAM data interface
    fmc{n}_tdc_data_bus_io : inout std_logic_vector(27 downto 0);
    fmc{n}_tdc_address_o   : out   std_logic_vector(3 downto 0);
    fmc{n}_tdc_cs_n_o      : out   std_logic;
    fmc{n}_tdc_oe_n_o      : out   std_logic;
    fmc{n}_tdc_rd_n_o      : out   std_logic;
    fmc{n}_tdc_wr_n_o      : out   std_logic;
    fmc{n}_tdc_ef1_i       : in    std_logic;
    fmc{n}_tdc_ef2_i       : in    std_logic;

    -- TDC1 Input Logic
    fmc{n}_tdc_enable_inputs_o : out std_logic;
    fmc{n}_tdc_term_en_1_o     : out std_logic;
    fmc{n}_tdc_term_en_2_o     : out std_logic;
    fmc{n}_tdc_term_en_3_o     : out std_logic;
    fmc{n}_tdc_term_en_4_o     : out std_logic;
    fmc{n}_tdc_term_en_5_o     : out std_logic;

    -- TDC1 1-wire UniqueID & Thermometer
    fmc{n}_tdc_one_wire_b : inout std_logic;

    -- TDC1 EEPROM I2C
    fmc{n}_tdc_scl_b : inout std_logic;
    fmc{n}_tdc_sda_b : inout std_logic;

    -- TDC1 LEDs
    fmc{n}_tdc_led_status_o : out std_logic;
    fmc{n}_tdc_led_trig1_o  : out std_logic;
    fmc{n}_tdc_led_trig2_o  : out std_logic;
    fmc{n}_tdc_led_trig3_o  : out std_logic;
    fmc{n}_tdc_led_trig4_o  : out std_logic;
    fmc{n}_tdc_led_trig5_o  : out std_logic;

    -- TDC1 Input channels
    -- also arriving to the FPGA (not used for the moment)
    fmc{n}_tdc_in_fpga_1_i : in std_logic;
    fmc{n}_tdc_in_fpga_2_i : in std_logic;
    fmc{n}_tdc_in_fpga_3_i : in std_logic;
    fmc{n}_tdc_in_fpga_4_i : in std_logic;
    fmc{n}_tdc_in_fpga_5_i : in std_logic;
